---
title: Ethics
updated: 2022-04-03 11:38:26Z
created: 2021-05-04 14:58:11Z
---

# Why is AI ethics becoming a problem now?

Machine learning (ML) through neural networks is advancing rapidly for three reasons:

1. Huge increase in the size of data sets; 
2. Huge increase in computing power;
3. Huge improvement in ML algorithms and more human talent to write them.

All three of these trends are centralizing of power, and “With great power comes great responsibility”

## Sixteen Challenges

1. **Technical Safety**
   Will AI systems work as they are promised or will they fail? If and when they fail, what will be the results of those failures? And if we are dependent upon them, will we be able to survive without them?
   Might legally reduce a manufacturer’s responsibility in terms and contracts => unethical scheme to avoid legitimate responsibility.
2. **Transparency and Privacy**
   Once we have determined that the technology functions adequately, can we actually understand how it works and properly gather data on its functioning? Ethical analysis always depends on getting the facts first—only then can evaluation begin.
   It turns out that with some machine learning techniques such as deep learning in neural networks it can be difficult or impossible to really understand why the machine is making the choices that it makes. In other cases, it might be that the machine can explain something, but the explanation is too complex for humans to understand.
   As an additional point, in general, the more powerful someone or something is, the more transparent it ought to be, while the weaker someone is, the more right to privacy he or she should have. Therefore the idea that powerful AIs might be intrinsically opaque is disconcerting.
3. **Beneficial Use & Capacity for Good**
   The main purpose of AI is to help people lead longer, more flourishing, more fulfilling lives.
4. **Malicious Use & Capacity for Evil**
   Artificial intelligence, like human intelligence, will be used maliciously, there is no doubt.
   Competition and war are always primary drivers of technological advance, and that militaries and corporations are working on these technologies right now. Not always intended. Because of this, forbidding, banning, and relinquishing certain types of technology would be the most prudent solution.
5. **Bias in Data, Training Sets, etc.**
   One of the interesting things about neural networks is that they effectively merge a computer program with the data that is given to it. Many benefits but also potential harm.
   Algorithmic bias is one of the major concerns in AI right now and will remain so in the future unless we endeavor to make our technological products better than we are.
6. **Unemployment / Lack of Purpose & Meaning**
   Automation of industry has been a major contributing factor in job losses since the beginning of the industrial revolution. AI will simply extend this trend to more fields ie law, medicine, and education.
   Attached to the concern for employment is the concern for how humanity spends its time and what makes a life well-spent.
7. **Growing Socio-Economic Inequality**
   Related to the unemployment problem is the question of how people will survive if unemployment rises to very high levels.
   Universal basic income (UBI) => major restructuring of national economies (political)
8. **Environmental Effects**
   Machine learning models require enormous amounts of energy to train ==> fossil fuels.  AI is in some very basic ways a technology focused on efficiency, and energy efficiency is one way that its capabilities can be directed.
9. **Automating Ethics**
   One strength of AI is that it can automate decision-making. Automation of decision making will presents huge problems for society, because if these automated decisions are good, society will benefit, but if they are bad, society will be harmed. => ethical standards needed.
   the ethical decision-making process might be as simple as following a program to fairly distribute a benefit, wherein the decision is made by humans and executed by algorithms, but it also might entail much more detailed ethical analysis, even if we humans would prefer that it did not—this is because Ai will operate so much faster than humans can, that under some circumstances humans will be left “out of the loop” of control due to human slowness. This already occurs with cyberattacks, and high-frequency trading (both of which are filled with ethical questions which are typically ignored) and it will only get worse as AI expands its role in society.
   Since AI can be so powerful, the ethical standards we give to it had better be good.
10. **Moral Deskilling & Debility**
   If we turn over our decision-making capacities to machines, we will become less experienced at making decisions. AI will be to either assist or replace humans at making certain types of decisions => humans may become worse at these skills.
11. **AI Consciousness, Personhood, and “Robot Rights”**
   Some thinkers have wondered whether AIs might eventually become self-conscious, attain their own volition, or otherwise deserve recognition as persons like ourselves.
   Legally => personhood has been given to corporations and (in other countries) rivers, so there is certainly no need for consciousness even before legal questions may arise.
   Morally => perhaps someday they will be such good imitations.
12. **AGI and Superintelligence**
    when AI reaches human levels of intelligence (AGI=Artificial General Intelligenc), potentially vastly more clever and capable than we are.
    There is no reason why the improvement of AI would stop at AGI => more hardware to do more and faster. Dethroning of humanity as the most intelligent thing on Earth.
13. **Dependency on AI**
    Our technological dependency is almost what defines us as a species. => complex and fragile
    Intelligence dependence is a form of dependence like that of a child to an adult.  raises the question of what an infantilized human race would do if our AI parents ever malfunctioned. Without that AI, if dependent on it, we could become like lost children not knowing how to take care of ourselves or our technological society.
14. **AI-powered Addiction**
    AI can exploit numerous human desires and weaknesses including purpose-seeking, gambling, greed, libido, violence, and so on. Addiction enslaves us and wastes our time when we could be doing something worthwhile. It is not the AIs that choose to treat people this way, it is other people.
15. **Isolation and Loneliness**
    One might think that “social” media, smartphones, and AI could help, but in fact they are major causes of loneliness since people are facing screens instead of each other. What does help are strong in-person relationships, precisely the relationships that are being pushed out by addictive (often AI-powered) technology. Loneliness can be helped by dropping devices and building quality in-person relationships. In other words: caring.
16. **Effects on the Human Spirit**
    By externalizing our intelligence and improving it beyond human intelligence, are we making ourselves second-class beings to our own creations?

[Artificial Intelligence and Ethics: Sixteen Challenges and Opportunities](https://www.scu.edu/ethics/all-about-ethics/artificial-intelligence-and-ethics-sixteen-challenges-and-opportunities/)


