---
title: Why open source_
updated: 2021-05-04 14:58:11Z
created: 2021-05-04 14:58:11Z
---

# Why open source

Cloud computing brought a completely new and agile way of thinking about the vendor/consumer business model with the pay-as-you-grow model and SaaS. This model forced vendors to become more efficient and accurate with respect to how they deliver their software and think about the value behind their product.
The world where the consumer was willing to pay for “shelfware” is long gone, as **cloud** has also empowered the consumer to be more sophisticated with the way they measure the value behind a product and make data-driven decisions.

With **open source**, the picture is a bit more complex. So, what is the value of being an open source product if the cost is no longer the key driving force? 
Open source changes the relationship between the vendor and the consumer from a relationship of mistrust and that of a passive consumer of a veritable “black box,” to a relationship of trust and partnership. Open source makes it possible for consumers to know exactly what they are getting before they buy the product, along with more ways to control the way they will consume a given product or shape it through code contribution, feature requests, etc. With non-open source technology, a consumer is dependent entirely on the vendor every step of the way.
The “free” part in open source also allows consumers to choose when to pay for a given product based on their adoption stage, and value that they are getting from the product. Many open source companies will allow you to use their products completely free with the assumption that as you grow and get more substantial value from the product, you’ll need support and specific hardening, and this is where they will see monetization. So, in a nutshell, open source allows consumers to pay for products only when they feel that they are getting enough value from them or want to grow with the value.

Open source is not just a technology choice but plays a key role from a business value perspective: scale. Successful open source companies tend to scale much faster than closed source alternatives.
The trust relationship that open source companies often have with their consumer also creates a higher degree of loyalty, and thus stickiness, which is one of the key factors that leads to that difference in scale when compared with non-open source alternatives.

The monetization process starts after the customer is already convinced and has been using the product for a while. Therefore, they would be much more receptive to moving forward quickly.

When Amazon started to provide managed offering of specific open source products, they were breaking right into the middle of this assumption. That broke the entire “trust system” that stood behind many 
of the open source models. 

___Amazon are abusing open source products to their benefit___

Google was the first to realize this with the launch of Kubernetes as an open source project and win more cloud business by demonstrating a “non lock-in” strategy with open source.
what’s in it for Google? t’s the same strategy that helped Google beat Apple in the smartphone business — launching Android as an open alternative to iOS.
Taking the open source route is an effective strategy to win the hearts and minds of developers. 

[Source](https://thenewstack.io/the-amazon-effect-on-open-source/)

Other sources:
https://opensource.com/life/15/12/why-open-source