# Time series

> A time series is a set of data points ordered in time.
The data is equally spaced in time, meaning that it was recorded at every hour, minute, month, or quarter.  Time series are indexed by time, and that order must be kept

Decomposition is defined as a statistical task that separates a time series into its different components:

![Trend](../_resources/Trend.png)
The **trend** is defined
as the slow-moving changes in a time series.
If you observe seasonality, then a **SARIMA model** would be relevant, because this
model uses seasonal effects to produce forecasts

![Seasonality](../_resources/Seasonallity.png)
 The **seasonal** component captures the seasonal variation, which is a cycle that occurs over a fixed period of time.

**Residuals**, which is what cannot be
explained by either the trend or the seasonal components. Residuals usually correspond to random errors, also termed **white noise**

![Seasonal and Cyclical](../_resources/Seasonal_and_cyclical.png)

![Seasonal and Trend](../_resources/Seasonallity_trend.png)

![Variation](../_resources/Variation.png)

![Bird’s-eye view of time series forecasting](../_resources/ForcastingProjectRoadmap.png)

> The only way to know that a model is good, or performant, is to compare it to a baseline. The baseline model is the simplest solution you can
think of—it should not require any training, and the cost of implementation should be very low.
A **baseline model** is a trivial solution to your forecasting problem. It relies on heuristics or simple statistics and is usually the simplest solution. It does not require
model fitting, and it is easy to implement.

For example:

- arithmetic mean
- if we see a cyclical pattern in our data, we can simply repeat that pattern into the future.
